//Immediately-Invoked Function Expression 
(function() {

    var sidebarTitles = $('.sidebarTitle').parent().parent();
    var sidebarClickableSections = [];
    var activeSection = '';
    var jsonFile ='assets/bdd/info.json';
    var localBdd = {};
    var posCalculatorCurrentNumber = "";
    var posCalculatorCurrentSecNumber = "";
    var posCalculatorCurrentAction = "";
    var resultContainer = '.current-calculator-line';
    var calculatorLinesContainer = '.current-sale .row';
    var currentSaleTotalAmount = '.curent-sale-number';
    var linesNumber = 0;
    var msgCalculatorNotRegisteredProduct = 'Not reg. product'; 
    var saleStarted = false;
    var isAdmin = false;
    var entitiyToDelete = {};
    var entityToEdit = {};

    //When document DOM ready for JavaScript, is the first time we load the webapp, so
    //we want to see the first section: POS
    $(function() {
        setLoggedUserInfo();
        //is is not Admin, remove the sidebar item to go see the Admin section
        if (!isAdmin){
            $('#sidebaradminitem').remove();
        }
        //when we log in, show the POS screen
        $('#posSidebar').click();
    });

    //populate array of sidebar clickable sections in order to load the section
    populateSidebarSectionsArray();

    //handle click on sidebars titles in order to change style
    $.each(sidebarTitles, function(i, e) {
        addChangeStyleListener(e, 'click');
    });

    //handle click on sidebars links in order to show the properly content at the website
    showHideSections();

    //get json file
    getBddInfo();

    //initialize pos calculator actions
    $(window).load(function(){
        posCalculator();
    });

    changeUserModalListeners();

    //add listener to edit or delete an entity: a product or a customer
    addDeleteEntityListener();
    addEditEntityListener();

    function addActiveClass(element) {
        $(element).addClass('active');
    }

    function addChangeStyleListener(element, event) {
        $(element).on(event, function() {
            removeActiveClassOthers(sidebarTitles);
            addActiveClass(this);
        });
    }

    function addDeleteEntityListener(){
        var  deleteEntityBtn = ".deleteentity";

        $(deleteEntityBtn).each(function(i,element){
            $(element).on('click', function(e){
                entitiyToDelete = $(this).parent().parent();
                
                //now, set the modal button to remove the row
                var confirmBtn = '';
                var closeBtn = '';

                if (entitiyToDelete.parent().parent().parent().attr('id') === 'customers-list'){
                    confirmBtn = '#confirmdeletecustomerbtn';
                    closeBtn = '#deleteCustomerModal .close';                   

                }
                else if (entitiyToDelete.parent().parent().parent().attr('id') === 'products-list'){
                    confirmBtn = '#confirmdeleteproductbtn';
                    closeBtn = '#deleteProductModal .close';
                }

                $(confirmBtn).on('click', function(e){
                    entitiyToDelete.remove();
                    //reset entity to delete
                    entitiyToDelete = {};
                    //close modal
                    $(closeBtn).click();
                });
            });
        });
    }

    function addEditEntityListener(){
        var editEntityBtn = '.editentity';
        
        $(editEntityBtn).each(function(i,element){
            $(element).on('click', function(e){
                var info = {};

                entityToEdit = $(this).parent().parent();

                //now, set the modal button to remove the row
                var confirmBtn = '';
                var closeBtn = '';
                var modalWindow = '';

                if (entityToEdit.parent().parent().parent().attr('id') === 'customers-list'){
                    //add listener to save button
                    addSaveEntityBtn('customers', this);

                    confirmBtn = '#confirmsaveuserbtn';
                    closeBtn = '#editCustomerModal .close'; 
                    modalWindow = '#editCustomerModal';

                    //fill the info object
                    info.firstname = $(this).data('customer-row-firstname');
                    info.lastname =  $(this).data('customer-row-lastname');    
                    info.gender =  $(this).data('customer-row-gender');       
                    info.phone =  $(this).data('customer-row-phone'); 
                    info.email =  $(this).data('customer-row-email');
                    $(modalWindow + ' #fullname').val(info.firstname);
                    $(modalWindow + ' #lastname').val(info.lastname);
                    $(modalWindow + ' #data-phone').val(info.phone);
                    $(modalWindow + ' #email').val(info.email);

                    //set gender
                    if (info.gender.toLowerCase() === 'male'){
                        $(modalWindow + ' #radio-male').click();
                    }
                    else if(info.gender.toLowerCase() === 'female'){
                        $(modalWindow + ' #radio-female').click();
                    }

                }
                else if (entityToEdit.parent().parent().parent().attr('id') === 'products-list'){
                    //add listener to save button
                    addSaveEntityBtn('products', this);

                    confirmBtn = '#confirmsaveproductbtn';
                    closeBtn = '#editProductModal .close';
                    modalWindow = '#editProductModal';

                    //fill the info object
                    info.productname = $(this).data('product-row-name');
                    info.productprice =  $(this).data('product-row-price');    
                    info.productqty =  $(this).data('product-row-qty');       
                    info.productcomments =  $(this).data('product-row-comments'); 
                    info.productvat = $(this).data('product-row-vat');
                    $(modalWindow + ' #productname').val(info.productname);
                    $(modalWindow + ' #productprice').val(info.productprice);
                    $(modalWindow + ' #productqty').val(info.productqty);
                    $(modalWindow + ' #freetext').val(info.productcomments);

                    //set gender
                    if (info.productvat === 4){
                        $(modalWindow + ' #radio-four').click();
                    }
                    else if(info.productvat === 10){
                        $(modalWindow + ' #radio-ten').click();
                    }    
                    else if(info.productvat === 21){
                        $(modalWindow + ' #radio-twentyone').click();
                    }                 
                }                

            });
        });        
    }

    function addSaveEntityBtn(entity, element){
        var btnConfirm = '';
        var elementDatas = $(element);
        var rowToModify = $(element).parent().parent();

        if (entity === 'customers'){
            btnConfirm = '#confirmsavecustomerbtn';
            $(btnConfirm).on('click',function(element){
                //check required fields
                var requiredContainer = $(this).parent().parent().parent();
                var firstName = requiredContainer.find('*[name="firstname"]');
                var lastName = requiredContainer.find('*[name="lastname"]');
                var phone = requiredContainer.find('*[name="phone"]');
                var email = requiredContainer.find('*[name="email"]');
                var comments = requiredContainer.find('*[name="freetext"]');
                var gender = $('input[name=radiorequired]:checked', '#editCustomerModal').val();

                //set border to grey
                firstName.css('border','1px solid #ccd0d4');
                lastName.css('border','1px solid #ccd0d4');

                if ( firstName.val() === ''){
                    firstName.css('border','1px solid red');
                    firstName.val('');
                    firstName.attr('placeholder', 'Required field');
                }
                else if (lastName.val() === ''){
                    lastName.css('border','1px solid red');
                    lastName.val('');
                    lastName.attr('placeholder', 'Required field');     
                }
                else {
                    //all required fields are filled
                    //set the data information
                    elementDatas.data('customer-row-firstname',firstName.val());
                    elementDatas.data('customer-row-lastanme',lastName.val());
                    elementDatas.data('customer-row-gender',gender);
                    elementDatas.data('customer-row-phone',phone.val());
                    elementDatas.data('customer-row-email',email.val());
                    elementDatas.data('customer-row-comments',comments.val());

                    //update info row
                    rowToModify.find('.rowcustomerfirstname').text(firstName.val());
                    rowToModify.find('.rowcustomerlastname').text(lastName.val());
                    rowToModify.find('.rowcustomerphone').text(phone.val());
                    rowToModify.find('.rowcustomeremail').text(email.val());

                    //close modal
                    $('#editCustomerModal .close').click();
                }
            });
        }
        else if(entity === 'products'){
            btnConfirm = '#confirmsaveproductbtn';
            $(btnConfirm).on('click',function(element){
                //check required fields
                var requiredContainer = $(this).parent().parent().parent();
                var productName = requiredContainer.find('*[name="productname"]');
                var productPrice = requiredContainer.find('*[name="productprice"]');
                var productQty = requiredContainer.find('*[name="productqty"]');
                var productComments = requiredContainer.find('*[name="freetext"]');
                var productVAT = $('input[name=radiorequired]:checked', '#editProductModal').val();

                /*var requiredContainer = $(this).parent().parent().parent();
                var productName = rowToModify.find('.rowproductname').text();
                var productPrice = rowToModify.find('.rowproductprice').text();
                var productQty = rowToModify.find('.rowproductqty').text();
                var productComments = rowToModify.find('.rowproductcomments').text();
                var productVAT = $('input[name=radiorequired]:checked', '#editProductModal').val();   */             

                //set border to grey
                productName.css('border','1px solid #ccd0d4');

                if (productName.val() === ''){
                    productName.css('border','1px solid red');
                    productName.val('');
                    productName.attr('placeholder', 'Required field');
                }
                else {
                    //all required fields are filled
                    //set the data information
                    elementDatas.data('product-row-name',productName.val());
                    elementDatas.data('product-row-price',productPrice.val());
                    elementDatas.data('product-row-vat',productVAT);
                    elementDatas.data('product-row-qty',productQty.val());
                    elementDatas.data('product-row-comments',productComments.val());

                    //update info row
                    rowToModify.find('.rowproductname').text(productName.val());
                    rowToModify.find('.rowproductprice').text(productPrice.val() + ' €');
                    rowToModify.find('.rowproductqty').text(productQty.val());
                    rowToModify.find('.rowproductvat').text(productVAT);
                    rowToModify.find('.rowproductcomments').text(productComments.val().substring(0,70));

                    //close modal
                    $('#editProductModal .close').click();
                }

            });            

        }
    }

    function changeUserModalListeners(){
        var userRow = '.changeusermodal';

        $(userRow).each(function(i,element){
            $(element).on('click',function(e){
                var employeeName = $(element).attr('data-employee-modal-name');

                //change navbar name and img
                setnavbaruserpicture(employeeName);
                setnavbarusername(employeeName);

                //close modal
                $('#changeUserModal .close').click();

                //remove param u from querystring
                history.pushState(null, 'TPVCloud', 'http://tpvcloud-uoctfm.rhcloud.com/index.html?u=' + employeeName);
            });
        });
    }

    function createStats(){
        createEmployeeStats('Today');
        createEmployeeStats('LastWeek');
        createEmployeeStats('LastMonth');
        createEmployeeStats('LastYear');
        createTotalSalesStats('LastWeek');
        createTotalSalesStats('LastYear');
    }

    function createEmployeeStats(when){

        var chart = {};
        var salesArray =[];

        switch (when){
            case 'Today':
                chart = $('#employee-chart-today');
                salesArray = [15,20,35,30];
                break;
            case 'LastWeek':
                chart = $('#employee-chart-lastweek');
                salesArray = [25,20,23,33];
                break;            
            case 'LastMonth':
                chart = $('#employee-chart-lastmonth');
                salesArray = [25,15,20,40];
                break;   
            case 'LastYear':
                chart = $('#employee-chart-lastyear');
                salesArray = [20,20,28,32];                
                break;   
        }

        if (chart.length !== 0) {

            var data = [];
            var series = 5;
            var colorArray = [dark, green, purple, red];
            var nameArray = ['Employee1', 'Employee1', 'Employee3', 'Employee4'];
            var dataArray = [20,14,12,31];
            for( var i = 0; i<series; i++)
            {
                data[i] = { label: nameArray[i], data: salesArray[i], color: colorArray[i] };
            }
            
            $.plot(chart, data, 
            {
                series: {
                    pie: { 
                        innerRadius: 0.5,
                        show: true,
                        combine: {
                            color: '#999',
                            threshold: 0.1
                        }
                    }
                },
                grid:{borderWidth:0, hoverable: true, clickable: true},
                legend: {
                    show: false
                }
            });
        }
    }

    function createTotalSalesStats(when){

        var chart = {};
        var salesArray = [];
        var profitArray = [];

        switch (when){
            case 'LastWeek':
                chart = $('#total-lastweek-sales-chart');
                salesArray = [[0, 42], [1, 53], [2,66], [3, 60], [4, 68], [5, 66], [6,71],[7, 75]];
                profitArray = [[0, 12], [1, 26], [2,13], [3, 18], [4, 35], [5, 23], [6, 18],[7, 35]];
                break;
            case 'LastYear':
                chart = $('#total-lastyear-sales-chart');
                salesArray = [[0, 42], [1, 53], [2,66], [3, 60], [4, 68], [5, 66], [6,71],[7, 75], [8, 69], [9,70], [10, 68], [11, 72], [12, 78], [13, 86]];
                profitArray = [[0, 12], [1, 26], [2,13], [3, 18], [4, 35], [5, 23], [6, 18],[7, 35], [8, 24], [9,14], [10, 14], [11, 29], [12, 30], [13, 43]];
                break;
        }

        function showTooltip(x, y, contents) {
            $('<div id="tooltip" class="flot-tooltip">' + contents + '</div>').css( {
                top: y - 45,
                left: x - 55
            }).appendTo("body").fadeIn(200);
        }

        if (chart.length !== 0) {
            
            $.plot(chart, [
                    {
                        data: salesArray, 
                        label: "Total sales", 
                        color: purple,
                        lines: { show: true, fill:false, lineWidth: 2 },
                        points: { show: false, radius: 5, fillColor: '#fff' },
                        shadowSize: 0
                    }, {
                        data: profitArray,
                        label: 'Profit',
                        color: green,
                        lines: { show: true, fill:false, lineWidth: 2, fillColor: '' },
                        points: { show: false, radius: 3, fillColor: '#fff' },
                        shadowSize: 0
                    }
                ], 
                {
                    xaxis: {  tickColor: '#ddd',tickSize: 2 },
                    yaxis: {  tickColor: '#ddd', tickSize: 20 },
                    grid: { 
                        hoverable: true, 
                        clickable: true,
                        tickColor: "#ccc",
                        borderWidth: 1,
                        borderColor: '#ddd'
                    },
                    legend: {
                        labelBoxBorderColor: '#ddd',
                        margin: 0,
                        noColumns: 1,
                        show: true
                    }
                }
            );

            var previousPoint = null;

            chart.bind("plothover", function (event, pos, item) {
                $("#x").text(pos.x.toFixed(2) + " €");
                $("#y").text(pos.y.toFixed(2) + " €");
                if (item) {
                    if (previousPoint !== item.dataIndex) {
                        previousPoint = item.dataIndex;
                        $("#tooltip").remove();
                        var y = item.datapoint[1].toFixed(2);
                        
                        var content = item.series.label + " " + y;
                        showTooltip(item.pageX, item.pageY, content);
                    }
                } else {
                    $("#tooltip").remove();
                    previousPoint = null;            
                }
                event.preventDefault();
            });
        } 
    }

    function getBddInfo(){
          $.getJSON(jsonFile)
            .done(function( data ) {
                //console.log(data);
                localBdd = data;
            });
    }    

    function getParameterByName(name) {
        name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
        var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
            results = regex.exec(location.search);
        return results === null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
    }

    function populateSidebarSectionsArray(){
        sidebarClickableSections.push($('#posSidebar'));
        sidebarClickableSections.push($('#listEditProductSidebar'));
        sidebarClickableSections.push($('#createProductSidebar'));
        sidebarClickableSections.push($('#listEditCustomerSidebar'));
        sidebarClickableSections.push($('#createCustomerSidebar'));
        sidebarClickableSections.push($('#accountingSidebar'));
        sidebarClickableSections.push($('#statsSidebar'));
        sidebarClickableSections.push($('#employeesSidebar'));
        sidebarClickableSections.push($('#companyDataSidebar'));        
    }

    function populateCustomersTable(container, customers){
        $.each(customers, function(i,e){
            container.append(startNewRow + e.firstName + endNewRow);
            container.append(startNewRow + e.lastName + endNewRow);
            container.append(startNewRow + e.phone + endNewRow);
            container.append(startNewRow + e.email + endNewRow);
            container.append(startNewRow + e.id+ endNewRow);
        });
    }

    function populateProductsTable(container, products){
        var startNewRow = '<td>';
        var endNewRow = '</td>';

        $.each(products, function(i,e){

        });        
    }

    function populateTable(entity){
        var customersTable = '#customers-list table tbody';
        var productsTable = '#products-list table tbody';
        var data = {};
        var table = {};

        if (entity === 'products'){
            table = $(productsTable);
            data = localBdd.products;
            populateProductsTable(table,data);

        }
        else if (entity === 'customers'){
            table = $(customersTable);
            data = localBdd.customers;
            populateCustomersTable(table,data);
        }
    }

    function posAddNewLine(productName, productPrice){
        linesNumber += linesNumber + 1;
        var newLineNumber = 'lineNumber' + linesNumber.toString();
        var lineTemplate1 = '<div class="calculator-selling-line"><span class="calculator-selling-line-product-name">' + productName + '</span>';
        var lineTemplate2 = lineTemplate1 + '<span class="calculator-delete-line pull-right" data-line-number="' + newLineNumber + '"><a href="javascript:;"><i class="fa fa-trash-o"></i></a></span>';
        var lineTemplate3 = lineTemplate2 + '<span class="calculator-selling-line-product-price" data-line-price="'+ productPrice + '">' + productPrice + ' €</span></div><br/>';

        //set the flat if we are starting a new sale
        if (saleStarted === false){
            saleStarted = true;
            posCalculatorToggleActionButtons('enable');
        }

        $(calculatorLinesContainer).prepend(lineTemplate3);
        updateCurrentSaleTotal(productPrice, 'add');


        //add listener to delete line
        $('[data-line-number="' + newLineNumber +'"]').on('click',function(elementProduct){
            var lineToDelete = $(elementProduct.currentTarget).siblings().parent();
            var productPrice = $(elementProduct.currentTarget).siblings('.calculator-selling-line-product-price').attr('data-line-price');

            updateCurrentSaleTotal(productPrice, 'subtract');
            lineToDelete.next().remove();
            lineToDelete.remove();  

            //check if there are not more products in the curren sale, in this case, disable action buttons
            if ($(calculatorLinesContainer).children().length === 0){
                posCalculatorToggleActionButtons('disable');
            }

        });

        //if not registered product new line
        if (productName === msgCalculatorNotRegisteredProduct){
            posCalculatorCurrentNumber= '';
            posCalculatorCurrentSecNumber = '';
            posCalculatorCurrentAction = '';
            $(resultContainer).html('N/A');          
        }
    }

    function posCalculator(){
        posCalculatorAddListeners();
        posProductsListAddListeners();
        posCalculatorToggleActionButtons('disable');
    }

    function posCalculatorActionsListeners(actionsKeys){

        $(actionsKeys).each(function(i,e){
            $(e).on('click', function(elementAction){
                var currentSymbol = $(elementAction.currentTarget).attr('data-calc-action');

                //if we have numbers, first, we calculate the current operation
                if ((posCalculatorCurrentNumber !== '') && (posCalculatorCurrentSecNumber !== '')){
                    posCalculatorCalculate();
                }

                var formerSymbols = $(resultContainer).html();

                if (formerSymbols !== 'N/A'){
                    switch (currentSymbol){
                        case 'subtract':
                            posCalculatorCurrentAction = '-';
                            $(resultContainer).html(formerSymbols + ' ' + '-' + ' ');
                            break;
                        case 'mult':
                            posCalculatorCurrentAction = '*';
                            $(resultContainer).html(formerSymbols + ' ' + '*' + ' ');
                            break;
                        case 'clear':
                            posCalculatorCurrentNumber= '';
                            posCalculatorCurrentSecNumber = '';
                            posCalculatorCurrentAction = '';
                            $(resultContainer).html('N/A');
                            break;
                        case 'add':
                            posCalculatorCurrentAction = '+';
                            $(resultContainer).html(formerSymbols + ' ' + '+' + ' ');
                            break;  
                        case 'equal':
                            posCalculatorCalculate();
                            break;  
                    }
                }
            });
        });

        //add new line button from calculator
        $('.calculator-add-btn').on('click', function(element){
            if (posCalculatorCurrentAction !== ''){
                if (posCalculatorCurrentSecNumber !== ''){
                    posCalculatorCalculate();
                }
                posAddNewLine(msgCalculatorNotRegisteredProduct, posCalculatorCurrentNumber);
            }
            else{
                if (($(resultContainer).html() !== 'N/A') && ($(resultContainer).html() !== '0.00')){
                    posAddNewLine(msgCalculatorNotRegisteredProduct, posCalculatorCurrentNumber);
                }
            }
        });

        //cancel current sale
        $('#cancelCurrentSaleModal .btn-primary').on('click', function(element){
            posCalculatorClearCurrentSale();
        });
    }

    function posCalculatorAddListeners(){
        var posCalculatorNumberKeys = '#posCalculator a[data-calc-number]';
        var posCaculatorPaymentKeys = '#posCalculator a[data-calc-payment]';
        var posCaculatorActionKeys = '#posCalculator a[data-calc-action]';

        posCalculatorNumberListeners(posCalculatorNumberKeys);
        posCalculatorActionsListeners(posCaculatorActionKeys);
        posCalculatorPaymentListeners(posCaculatorPaymentKeys);
    }

    function posCalculatorCalculate(){

        if ((posCalculatorCurrentNumber !== '') && (posCalculatorCurrentSecNumber !== '')) {
            var actionsSymbols = new Array('+', '-', '*');

            //console.log('CALCULATING: ',posCalculatorCurrentNumber, posCalculatorCurrentAction, posCalculatorCurrentSecNumber);

            if (actionsSymbols.indexOf(posCalculatorCurrentAction) !== -1){

                switch (posCalculatorCurrentAction){
                    case '+':
                        posCalculatorCurrentNumber = parseFloat(parseFloat(posCalculatorCurrentNumber) + parseFloat(posCalculatorCurrentSecNumber)).toFixed(2);
                        break;
                    case '-': 
                        posCalculatorCurrentNumber = parseFloat(parseFloat(posCalculatorCurrentNumber) - parseFloat(posCalculatorCurrentSecNumber)).toFixed(2);
                        break;  
                    case '*':
                        posCalculatorCurrentNumber = parseFloat(parseFloat(posCalculatorCurrentNumber) * parseFloat(posCalculatorCurrentSecNumber)).toFixed(2);                        
                        break;                    
                }

                $(resultContainer).html(posCalculatorCurrentNumber);
                posCalculatorCurrentAction = '';
                posCalculatorCurrentSecNumber = '';
            }
        }
    }

    function posCalculatorClearCurrentSale(){
            //clean calculator result div
            $(resultContainer).html('N/A'); 

            //clean calculator total amount div
            $(currentSaleTotalAmount).html('');

            //clean sales lines 
            $('.current-sale .row').children().remove();

            //disable action buttons
            posCalculatorToggleActionButtons('disable');        
    }

    function posCalculatorNumberListeners(numberKeys){

        $(numberKeys).each(function(i,e){
            $(e).on('click', function(elementNumber){
                var currentSymbol = $(elementNumber.currentTarget).attr('data-calc-number');
                var formerSymbols = $(resultContainer).html() === 'N/A' ? '' : $(resultContainer).html();

                if (currentSymbol === 'dec'){
                        if ((posCalculatorCurrentAction !== '') && (posCalculatorCurrentSecNumber.indexOf('.') === -1)){
                            posCalculatorCurrentSecNumber += '.';
                            $(resultContainer).html(formerSymbols + '.');
                        }
                        else if (posCalculatorCurrentNumber.indexOf('.') === -1){
                            posCalculatorCurrentNumber += '.';
                            $(resultContainer).html(formerSymbols + '.');
                        }
                        
                }
                else {
                        if (posCalculatorCurrentAction !== ''){
                            posCalculatorCurrentSecNumber += currentSymbol;
                        }
                        else {
                            posCalculatorCurrentNumber += currentSymbol;
                        }
                        $(resultContainer).html(formerSymbols + currentSymbol);
                }

            });
        });
    }

    function posCalculatorPaymentListeners(){
    }

    function posCalculatorToggleActionButtons(action){
        if (action === 'enable'){
            //enable payment buttons
            $('*[data-calc-payment="payment-cash"]').removeAttr('disabled');
            $('*[data-calc-payment="payment-card"]').removeAttr('disabled');

            //enable cancel sale button
            $('*[data-calc-action="cancel-sale"]').removeAttr('disabled');

            //set the flag
            saleStarted = true;
        }
        else if (action === 'disable'){
            //disable payment buttons
            $('*[data-calc-payment="payment-cash"]').attr('disabled','true');
            $('*[data-calc-payment="payment-card"]').attr('disabled','true');

            //disable cancel sale button
            $('*[data-calc-action="cancel-sale"]').attr('disabled','true');

            //set the flag
            saleStarted = false;
        }
    }

    function posProductsListAddListeners(){
        var productsListContainer = '.pos-products-list .pos-product-list';

        $(productsListContainer).each(function(i,e){
            $(e).on('click', function(elementProduct){
                var productClicked = $(elementProduct.currentTarget).find('img');
                var productName = productClicked.attr('data-product-name');
                var productPrice = productClicked.attr('data-product-price');

                posAddNewLine(productName, productPrice);
            });
        });
    }    

    function removeActiveClassOthers(elements) {
        $(elements).removeClass('active');
        $.each(elements, function(i, e) {
            $(e).removeClass('active');
        });
    }

    function rowsAddListener(entity){
    }    

    function setLoggedUserInfo(){        
        var userLogged = getParameterByName('u');
     
        if (userLogged !== ''){
            if (userLogged === 'administrator'){
                isAdmin = true;
            }
            //ser name
            setnavbarusername(userLogged);
            //set picture
            setnavbaruserpicture(userLogged);
        }
        else{
            setnavbarusername('employee1');
        }

        //set listener of user submenu
        $('#logoutlink').on('click',function(element){
            window.location.href = "http://tpvcloud-uoctfm.rhcloud.com/login.html";
        });
    }

    function setnavbarusername(employee){
        var navbarUserName = '#navbarusername';

        $(navbarusername).text(employee);
    }

    function setnavbaruserpicture(employee){
        var usernavbarimg = '#userimgnavbar';
        var imgpath = 'assets/img/' + employee + '.jpg';

        $(userimgnavbar).attr('src',imgpath);
    }

    function showHideSections(){
        $.each(sidebarClickableSections, function(i, item){
            item.on('click', function (e){

                // first hide current content
                $('.content > div:not(.hide)').addClass('hide');

                //now show the new content
                switch ($(e.currentTarget).attr('id')){
                    case 'posSidebar':
                        $('#pos_content').removeClass('hide');
                        break;
                    case 'listEditProductSidebar':
                        $('#products_content').removeClass('hide');
                        //populateTable('products');
                        break;
                    case 'createProductSidebar':
                        $('#products_content').removeClass('hide');
                        break;
                    case 'listEditCustomerSidebar':
                        $('#customers_content').removeClass('hide');
                        //populateTable('customers');
                        break;
                    case 'createCustomerSidebar':
                        $('#customers_content').removeClass('hide');
                        break;
                    case 'accountingSidebar':
                        $('#accounting_content').removeClass('hide');
                        break;
                    case 'statsSidebar':
                        $('#stats_content').removeClass('hide');
                        createStats();
                        break;
                    case 'employeesSidebar':
                        $('#employees_content').removeClass('hide');
                        break;
                    case 'companyDataSidebar':
                        $('#companydata_content').removeClass('hide');
                        break;
                }
            });
        });
    }    

    function updateCurrentSaleTotal(price, action){
        var totalCurrent = $(currentSaleTotalAmount).html();

        if (totalCurrent === '' || totalCurrent === '0€'){
            $(currentSaleTotalAmount).html(price + '€');
            $(currentSaleTotalAmount).attr('data-current-total', price);
        }
        else {
            var currentTotalAmount = $(currentSaleTotalAmount).attr('data-current-total');

            if (action === 'add') {
                currentTotalAmount = +(parseFloat(currentTotalAmount) + parseFloat(price)).toFixed(2);
            }
            else if (action === 'subtract'){
                currentTotalAmount = +(parseFloat(currentTotalAmount) - parseFloat(price)).toFixed(2);
            }
            $(currentSaleTotalAmount).html(currentTotalAmount + '€');
            $(currentSaleTotalAmount).attr('data-current-total', currentTotalAmount);      

        }
    }

})()
